REM QBCRead1.bas   (was = Combine6.bas)

DEFINT A-Z

'does not do queenside castle as yet

DECLARE SUB Instructions ()
DECLARE SUB Proof12 (Totlines%)
DECLARE SUB Resetter (ThisPiece%)
DECLARE SUB ComputeElement (Vertical$, Horizontal$, h, v)
DECLARE SUB GetFromTo (ThisMove$)
DECLARE SUB FromToMove (ThisMove$)
DECLARE SUB DivideMoves (CurrentLine$, WhiteMove$, BlackMove$)
DECLARE SUB Trimmer (Temp$)
DECLARE SUB GetPieces (Cycle%)
DECLARE SUB MaskPieces ()
DECLARE SUB GetPiecesMask ()
DECLARE SUB Proof11 ()
DECLARE SUB Proof10 ()
DECLARE SUB GetCoords (h%, w%, x%, y%, Offset%, OldPiece%)
DECLARE SUB UpdateBoard ()
DECLARE SUB MakeSquareGraphics ()
DECLARE SUB DrawBoard ()
DECLARE SUB FillBoardSquares ()
DECLARE SUB SetUpBoardStart ()
DECLARE SUB ChangePalette ()
DECLARE SUB GetFileName (FFileNName$)
DECLARE SUB CheckName (FFileNName$, Sucess%)
DECLARE SUB LoadDimListing (Sucess%, Totlines%, FFileNName$)
'*****************************************************
'Illustration of board and pieces graphics
'Masked allows for simulation
'This is set to do  the cut and paste for board setup
'*****************************************************

CONST TRUE = -1, FALSE = 0

' individual piece uses a dim of 67 elements
DIM SHARED Squares(67 * 2)
DIM SHARED WPieces(67 * 6)
DIM SHARED BPieces(67 * 6)
DIM SHARED PiecesMask(67 * 6)
DIM SHARED Board(8, 8)
DIM SHARED BoardSquares(8, 8)
DIM SHARED MoveFrom(4), MoveTo(4) 'MoveFromDim 1=row , 2= col
DIM SHARED MoveList$(256 * 12)
DIM SHARED WhosMove(1), MoveList(1), Totlines(1), Special(1), Castleing(1)
'****************************** MAIN *********************************
Succes = FALSE: FFileName$ = "": Totlines = 0
SCREEN 12

Instructions
GOSUB Init
GetFileName FFileNName$
CheckName FFileNName$, Succes

MoveList(1) = 1 '<== move number
LoadDimListing Succes, Totlines, FFileNName$
Proof12 Totlines

WhosMove(1) = 1
DO
  DivideMoves CurrentLine$, WhiteMove$, BlackMove$
  IF WhosMove(1) = 1 THEN
    FromToMove WhiteMove$
    GetFromTo WhiteMove$
    WhosMove(1) = 2
  ELSE
    FromToMove BlackMove$
    GetFromTo BlackMove$
    WhosMove(1) = 1
    MoveList(1) = MoveList(1) + 1
  END IF

  ThisPiece = Board(MoveFrom(1), MoveFrom(2)) 'place piece in temp variable
  Board(MoveFrom(1), MoveFrom(2)) = 0 'empty from square
  Board(MoveTo(1), MoveTo(2)) = ThisPiece 'put piece back to new square
  IF Castleing(1) = 1 THEN
    ThisPiece = Board(MoveFrom(3), MoveFrom(4))
    Board(MoveFrom(3), MoveFrom(4)) = 0
    Board(MoveTo(3), MoveTo(4)) = ThisPiece
    Castleing(1) = 0
  END IF
  Resetter ThisPiece
  'BEEP
  'check for pawn promotion
  FOR h = 0 TO 7
    IF Board(7, h) = 1 THEN Board(7, h) = 5
    IF Board(0, h) = -1 THEN Board(7, h) = -5
  NEXT h

  DrawBoard
  UpdateBoard 'update board with new pieces
  LOCATE 1, 30: PRINT WhiteMove$, MoveList(1), BlackMove$
  'SLEEP 3
  Dummy$ = INPUT$(1)
  IF UCASE$(Dummy$) = "Q" THEN Done = 1
LOOP WHILE Done = 0

SLEEP
PALETTE
END

'****************************** END **********************************
Init:
Odd = TRUE
FillBoardSquares 'load color square into board square dim
Proof10 'show square colors
SetUpBoardStart 'load pieces into board dim
Proof11 'show board pieces
'SLEEP 3
GOSUB StartUp
MakeSquareGraphics 'draw dark and light square graphics
DrawBoard 'draw entire board
RETURN

StartUp:
ChangePalette 'change the palette
GOSUB LoadPieces 'load the graphics
FOR Cycle = 1 TO 2
  GetPieces Cycle
NEXT Cycle
MaskPieces
GetPiecesMask
CLS
RETURN

LoadPieces: ' Load all pieces.
FOR y = 0 TO 31 '64 pixels
  FOR x = 0 TO 95 '96 pixels
    READ z
    IF z = 11 THEN z = 14
    IF z = 12 THEN z = 9
    PSET (x, y), z 'draw pic top left
  NEXT x
NEXT y
RETURN

'*********************************
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,13,13,13,0,13,13,13,13,0,13,13,13,0,0,0,0,0,0,0,13,13,0,13,13,0,0,0,0,0,0,0,0,0,0,0,13,13,13,0,13,13,13,0,0,0,0,0,0,0,0,13,13,13,0,0,0,13,13,13,0,0,0,0,0,0,0,0,0,13,13,13,13,13,13,0,0,0,0,0,0,0,0,0,0,0,0,13,13,0,0,0,0,0,0
DATA 0,0,13,13,13,0,13,13,13,13,0,13,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,0,0,0,0,0,0,0,0,0,0,13,7,13,0,13,7,13,0,0,0,0,0,0,0,0,13,7,13,0,0,0,13,7,13,0,0,0,0,0,0,13,13,0,13,7,13,13,7,13,0,13,13,0,0,0,0,0,0,0,0,13,13,13,13,0,0,0,0,0
DATA 0,0,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,13,13,13,7,13,13,0,0,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,0,13,13,13,0,0,0,13,13,13,0,0,0,0,0,13,13,13,13,13,13,7,7,13,13,13,13,13,13,0,0,0,0,0,0,0,13,13,13,13,0,0,0,0,0
DATA 0,0,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,13,13,13,13,13,13,13,7,13,13,0,0,0,0,0,0,0,13,13,13,13,13,7,13,13,13,0,0,0,0,0,0,0,0,13,13,0,0,0,13,13,0,0,0,0,0,0,13,13,13,13,13,7,13,13,7,13,13,13,13,13,0,0,0,0,0,13,13,13,13,13,13,13,13,0,0,0
DATA 0,0,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,13,13,13,13,7,7,13,13,13,7,13,0,0,0,0,0,0,13,13,13,13,13,13,13,7,13,13,13,0,0,0,13,13,13,0,13,13,13,0,13,13,13,0,13,13,13,0,0,13,13,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,13,13,13,13,13,13,13,13,13,13,0,0
DATA 0,0,0,13,13,7,7,7,7,7,7,13,13,0,0,0,0,13,13,13,13,7,7,13,13,13,13,7,13,13,0,0,0,0,0,13,13,13,13,13,13,13,7,13,13,13,0,0,0,13,7,13,0,13,13,13,0,13,13,13,0,13,7,13,0,0,13,13,13,13,13,13,7,7,13,13,13,13,13,13,0,0,0,0,0,0,0,0,13,13,0,0,0,0,0,0
DATA 0,0,0,0,13,13,13,13,13,13,13,13,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,7,13,0,0,0,0,0,13,13,13,13,13,13,13,13,7,13,13,0,0,0,13,13,13,0,13,13,13,13,13,13,13,0,13,13,13,0,0,13,13,13,13,13,13,7,7,13,13,13,13,13,13,0,0,0,0,0,0,0,13,13,13,13,0,0,0,0,0
DATA 0,0,0,0,13,13,13,13,13,13,13,13,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,7,13,13,0,0,0,0,13,13,13,13,13,13,13,13,7,13,13,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,13,13,13,13,13,7,7,13,13,13,13,13,0,0,0,0,0,0,0,0,13,13,13,13,0,0,0,0,0
DATA 0,0,0,0,13,13,13,13,13,13,13,13,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,13,7,13,0,0,0,0,13,13,13,13,13,13,13,13,7,13,13,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,13,7,13,13,7,7,13,13,7,13,0,0,0,0,0,0,0,0,13,13,13,13,13,13,0,0,0,0
DATA 0,0,0,0,13,13,13,13,13,13,13,13,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,13,7,13,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,13,7,7,7,7,7,7,7,7,13,0,0,0,0,0,0,0,0,13,13,13,13,13,13,0,0,0,0
DATA 0,0,0,0,13,13,13,13,13,13,13,13,0,0,0,0,0,13,13,13,0,0,13,13,13,13,13,13,13,7,13,0,0,0,0,0,13,13,7,7,7,7,7,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,0,0,13,13,13,13,13,13,0,0,0,0
DATA 0,0,0,13,13,7,7,7,7,7,7,13,13,0,0,0,0,0,0,0,0,13,13,13,13,13,13,13,13,7,13,0,0,0,0,0,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,7,13,13,7,13,13,7,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,0,0,0,13,13,13,13,0,0,0,0,0
DATA 0,0,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,7,13,0,0,0,0,0,0,13,7,7,7,7,7,13,0,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,7,13,13,7,7,13,13,7,13,0,0,0,0,0,0,0,13,13,13,13,13,13,13,13,0,0,0
DATA 0,0,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,0,0,0,13,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,13,13,13,0,13,13,13,13,0,13,13,13,0,0,0,0,0,0,0,13,13,0,13,13,0,0,0,0,0,0,0,0,0,0,13,13,13,0,13,13,13,0,0,0,0,0,0,0,0,0,13,13,13,0,0,0,13,13,13,0,0,0,0,0,0,0,0,0,13,13,13,13,13,13,0,0,0,0,0,0,0,0,0,0,0,0,13,13,0,0,0,0,0,0
DATA 0,0,13,7,13,0,13,7,7,13,0,13,7,13,0,0,0,0,0,0,13,13,13,13,13,13,13,0,0,0,0,0,0,0,0,0,13,7,13,0,13,7,13,0,0,0,0,0,0,0,0,0,13,7,13,0,0,0,13,7,13,0,0,0,0,0,0,13,13,13,13,7,13,13,7,13,13,13,13,0,0,0,0,0,0,0,0,13,7,7,13,0,0,0,0,0
DATA 0,0,13,7,7,13,13,7,7,13,13,7,7,13,0,0,0,0,0,0,13,7,7,7,7,7,13,13,0,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,0,0,13,13,13,0,0,0,13,13,13,0,0,0,0,0,13,13,7,7,13,13,7,7,13,13,7,7,13,13,0,0,0,0,0,0,0,13,7,7,13,0,0,0,0,0
DATA 0,0,13,7,7,7,7,7,7,7,7,7,7,13,0,0,0,0,0,13,13,7,7,7,7,7,7,13,13,0,0,0,0,0,0,13,7,7,7,13,13,7,7,13,0,0,0,0,0,0,0,0,0,13,13,0,0,0,13,13,0,0,0,0,0,0,13,7,7,7,13,7,13,13,7,13,7,7,7,13,0,0,0,0,0,13,13,7,7,7,7,13,13,0,0,0
DATA 0,0,13,7,7,7,7,7,7,7,7,7,7,13,0,0,0,0,13,13,7,7,13,13,7,7,7,7,13,0,0,0,0,0,13,13,7,7,7,7,13,13,7,13,13,0,0,0,0,13,13,13,0,13,13,13,0,13,13,13,0,13,13,13,0,0,13,7,7,7,13,13,13,13,13,13,7,7,7,13,0,0,0,0,13,13,13,13,13,13,13,13,13,13,0,0
DATA 0,0,0,13,13,13,13,13,13,13,13,13,13,0,0,0,0,13,13,7,7,13,13,7,7,7,7,7,13,13,0,0,0,0,13,7,7,7,7,7,7,13,7,7,13,0,0,0,0,13,7,13,0,13,7,13,0,13,7,13,0,13,7,13,0,0,13,7,7,7,7,13,7,7,13,7,7,7,7,13,0,0,0,0,0,0,0,0,13,13,0,0,0,0,0,0
DATA 0,0,0,0,13,7,7,7,7,7,7,13,0,0,0,0,0,13,7,7,7,7,7,7,7,7,7,7,7,13,0,0,0,0,13,7,7,7,7,7,7,13,13,7,13,0,0,0,0,13,13,13,0,13,7,13,13,13,7,13,0,13,13,13,0,0,13,13,7,7,7,13,7,7,13,7,7,7,13,13,0,0,0,0,0,0,0,13,13,13,13,0,0,0,0,0
DATA 0,0,0,0,13,7,7,7,7,7,7,13,0,0,0,0,0,13,7,7,7,7,7,7,7,13,7,7,7,13,13,0,0,0,13,7,7,7,7,7,7,7,13,7,13,0,0,0,0,0,13,13,13,13,7,13,13,13,7,13,13,13,13,0,0,0,0,13,13,13,7,13,7,7,13,7,13,13,13,0,0,0,0,0,0,0,0,13,7,7,13,0,0,0,0,0
DATA 0,0,0,0,13,7,7,7,7,7,7,13,0,0,0,0,0,13,7,7,7,7,7,7,13,13,7,7,7,7,13,0,0,0,13,7,7,7,7,7,7,7,13,13,13,0,0,0,0,0,13,7,13,7,7,7,13,7,7,7,13,7,13,0,0,0,0,0,13,7,13,13,7,7,13,13,7,13,0,0,0,0,0,0,0,0,13,7,7,7,7,13,0,0,0,0
DATA 0,0,0,0,13,7,7,7,7,7,7,13,0,0,0,0,0,13,7,13,13,13,13,13,13,7,7,7,7,7,13,0,0,0,13,13,7,7,7,7,7,7,7,13,13,0,0,0,0,0,13,13,13,7,7,7,13,7,7,7,13,13,13,0,0,0,0,0,13,7,7,7,7,7,7,7,7,13,0,0,0,0,0,0,0,0,13,7,7,7,7,13,0,0,0,0
DATA 0,0,0,0,13,7,7,7,7,7,7,13,0,0,0,0,0,13,13,13,0,0,13,13,7,7,7,7,7,7,13,0,0,0,0,13,7,7,7,7,7,7,7,13,0,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,0,0,13,7,7,7,7,13,0,0,0,0
DATA 0,0,0,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,0,0,13,13,7,7,7,7,7,7,7,13,0,0,0,0,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,0,13,7,7,7,7,7,7,7,7,7,13,0,0,0,0,0,0,13,7,7,7,7,7,7,7,7,13,0,0,0,0,0,0,0,0,0,13,7,7,13,0,0,0,0,0
DATA 0,0,13,13,7,7,7,7,7,7,7,7,13,13,0,0,0,0,0,0,13,13,7,7,7,7,7,7,7,7,13,0,0,0,0,0,13,7,7,13,7,7,13,0,0,0,0,0,0,0,0,13,7,13,7,7,13,7,7,13,7,13,0,0,0,0,0,0,13,7,13,7,13,13,7,13,7,13,0,0,0,0,0,0,0,13,13,13,7,7,13,13,13,0,0,0
DATA 0,0,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,0,0,0,13,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,0,0,0,0,0,0,13,13,13,13,13,13,13,13,13,13,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

'*****************
ErrorHandler:
LOCATE 24, 1: PRINT "An Error has occured="; ERR
BEEP
Dummy$ = INPUT$(1)
END

SUB ChangePalette
PALETTE 0, 328975 'Summer Black
PALETTE 1, 2752512 'Blue
PALETTE 2, 10752 'Green
PALETTE 3, 4144959 'Bright white
PALETTE 4, 42 'Red
PALETTE 5, 2169374 'Silver
PALETTE 6, 660778 'Brown
PALETTE 7, 2763306 'White
PALETTE 8, 1381653 'Grey
PALETTE 9, 4128768 'Air Force Blue
PALETTE 10, 2367012 'Tank Grey
PALETTE 11, 2761764 'Battle Grey
PALETTE 12, 1847601 'My Straw
PALETTE 13, 0 'Black
PALETTE 14, 1392447 'Yellow
PALETTE 15, 4133951 'Pink
END SUB

SUB CheckName (FFileNName$, Succes)
IF FFileNName$ <> "" THEN
  FFileNName$ = FFileNName$ + ".txt"
  Succes = TRUE
ELSE
  Succes = FALSE
  'exit out sub
END IF
END SUB

SUB ComputeElement (Vertical$, Horizontal$, h, v)
'letter symbols first
Trimmer Vertical$
Vertical$ = UCASE$(Vertical$)
'LOCATE 3, 40: 'PRINT Vertical$
SELECT CASE Vertical$
  CASE IS = "A"
    h = 0
  CASE IS = "B"
    h = 1
  CASE IS = "C"
    h = 2
  CASE IS = "D"
    h = 3
  CASE IS = "E"
    h = 4
  CASE IS = "F"
    h = 5
  CASE IS = "G"
    h = 6
  CASE IS = "H"
    h = 7
END SELECT

'numbers next
Trimmer Horizontal$
v = VAL(Horizontal$)
v = v - 1
'LOCATE 4, 40: 'PRINT H, V
'STOP
END SUB

SUB DivideMoves (CurrentLine$, WhiteMove$, BlackMove$)
CurrentLine$ = MoveList$(MoveList(1)) 'read current line
Trimmer CurrentLine$
Length = LEN(CurrentLine$)

'divide line into seperate moves
FOR t = 1 TO Length
  A$ = MID$(CurrentLine$, t, 1)
  IF A$ = " " THEN EXIT FOR
NEXT t
WhiteMove$ = LEFT$(CurrentLine$, t - 1)
Trimmer WhiteMove$

FOR t = Length TO 1 STEP -1
  A$ = MID$(CurrentLine$, t, 1)
  IF A$ = " " THEN EXIT FOR
NEXT t
BlackMove$ = RIGHT$(CurrentLine$, Length - t)
Trimmer BlackMove$
END SUB

SUB DrawBoard
'LINE (0, 0)-(640, 480), 7, BF
LINE (100, 100)-(228, 228), 7, BF
Odd = TRUE
FOR x = 100 TO 212 STEP 16
  FOR y = 100 TO 212 STEP 16
    IF Odd THEN
      PUT (x, y), Squares(0)
    ELSE
      PUT (x, y), Squares(67)
    END IF
    Odd = NOT (Odd)
  NEXT y
  Odd = NOT (Odd)
NEXT x
END SUB

SUB FillBoardSquares
' make the dim represent a real board with
' 0,0 equalling bottom left corner of chess board
Odd = FALSE
FOR height = 0 TO 7
  FOR wwidth = 0 TO 7
    IF Odd THEN
      BoardSquares(height, wwidth) = 1 'white
    ELSE
      BoardSquares(height, wwidth) = 0 'black
    END IF
    Odd = NOT (Odd)
  NEXT wwidth
  Odd = NOT (Odd)
NEXT height
END SUB

SUB FromToMove (ThisMove$)
LLength = LEN(ThisMove$)
SELECT CASE LLength
  CASE IS = 3
    'kingside castle
    Special(1) = 2
    'STOP
  CASE IS = 5
    'posible normal or queenside castle
    IF ThisMove$ = "0-0-0" THEN
      Special(1) = 3
    ELSE
      Special(1) = 1
    END IF
  CASE IS = 7
    IF RIGHT$(ThisMove$, 1) = "P" THEN
      'pawn en passent
      Special(1) = 4
    ELSE
      'pawn promotion
      Special(1) = 5
    END IF
END SELECT

END SUB

SUB GetCoords (h, w, x, y, Offset, OldPiece)

ThisWidth = h
SELECT CASE ThisWidth
  CASE IS = 0
    Extra = 112
  CASE IS = 1
    Extra = 96
  CASE IS = 2
    Extra = 80
  CASE IS = 3
    Extra = 64
  CASE IS = 4
    Extra = 48
  CASE IS = 5
    Extra = 32
  CASE IS = 6
    Extra = 16
  CASE IS = 7
    Extra = 0
END SELECT

x = 100 + Extra
y = 100 + (w * 16)

'Offset = h * 67
Piece = ABS(OldPiece)
SELECT CASE Piece
  CASE IS = 1 'P
    Offset = 335
  CASE IS = 2 'R
    Offset = 0
  CASE IS = 3 'N
    Offset = 67
  CASE IS = 4 'B
    Offset = 134
  CASE IS = 5 'Q
    Offset = 201
  CASE IS = 6 'K
    Offset = 268
END SELECT
END SUB

SUB GetFileName (FFileNName$)
'Routine that allows max of 8 characters to be entered
'Routine handles backspace and aborts on escape
'Routine concludes on name of 1 to 8 with enter
'allowed characters for legal file names
LegalOption$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ~-_1234567890"
Escape$ = CHR$(27): Backspace$ = CHR$(8)
Temp$ = "": K$ = "": Done% = 0: Abort = 0: Temp = 0
DO
  Temp = LEN(Temp$)
  LOCATE 20, 1: PRINT "File Name is ??_"; Temp$
  K$ = INPUT$(1)
  K$ = UCASE$(K$)
  IF K$ = Escape$ THEN
    Done% = 1
    Abort% = 1
  END IF
  IF K$ = Backspace$ THEN
    IF Temp > 0 THEN 'if length is greater than 1 trim it
      Temp$ = LEFT$(Temp$, Temp - 1)
    END IF
  END IF
  Legal% = INSTR(LegalOption$, K$)
  IF Legal% > 0 THEN Temp$ = Temp$ + K$
  IF LEN(Temp$) = 8 THEN Done% = 1
  IF LEN(Temp$) > 1 AND K$ = CHR$(13) THEN Done% = 1
  IF Abort = 1 THEN Temp$ = ""

  LOCATE 20, 17: PRINT "        "
  LOCATE 20, 17: PRINT Temp$

LOOP WHILE Done% = 0
FFileNName$ = Temp$: Temp$ = "": K$ = ""
'LOCATE 22, 20: PRINT "Name="; FFileNName$    '<<== reference
BEEP

END SUB

SUB GetFromTo (ThisMove$)
Special = Special(1)
SELECT CASE Special
  CASE IS = 1 'normal move
    From$ = LEFT$(ThisMove$, 2)
    Vertical$ = LEFT$(From$, 1)
    Horizontal$ = RIGHT$(From$, 1)
    'LOCATE 2, 40: 'PRINT Vertical$, , Horizontal$, H, V
    'H and V must be passed back and used
    ComputeElement Vertical$, Horizontal$, h, v
    MoveFrom(1) = v: MoveFrom(2) = h
    Too$ = RIGHT$(ThisMove$, 2)
    Vertical$ = LEFT$(Too$, 1)
    Horizontal$ = RIGHT$(Too$, 1)
    'LOCATE 5, 40: 'PRINT Vertical$, , Horizontal$, H, V
    ComputeElement Vertical$, Horizontal$, h, v
    MoveTo(1) = v: MoveTo(2) = h
  CASE IS = 2 'kingside castle
    IF Special(1) = 2 THEN
      Castleing(1) = 1
    END IF
    IF WhosMove(1) = 1 THEN
      'white
      MoveFrom(1) = 0: MoveFrom(2) = 4
      MoveTo(1) = 0: MoveTo(2) = 6
      MoveFrom(3) = 0: MoveFrom(4) = 7
      MoveTo(3) = 0: MoveTo(4) = 5
    ELSE
      'black
      MoveFrom(1) = 7: MoveFrom(2) = 4 'king
      MoveTo(1) = 7: MoveTo(2) = 6 'king
      MoveFrom(3) = 7: MoveFrom(4) = 7
      MoveTo(3) = 7: MoveTo(4) = 5
    END IF
    'STOP
  CASE IS = 3 'queenside castle

  CASE IS = 4 'en passant

  CASE IS = 5 'pawn promotion

END SELECT
Special(1) = 0
END SUB

SUB GetPieces (Cycle%)
Offset = 0
FOR t = 0 TO 95 STEP 16
  IF Cycle = 1 THEN
    GET (t, 0)-(t + 15, 15), BPieces(Offset)
  ELSE
    GET (t, 16)-(t + 15, 31), WPieces(Offset)
  END IF
  Offset = Offset + 67
NEXT t
END SUB

SUB GetPiecesMask
Offset = 0
FOR t = 0 TO 95 STEP 16
  GET (t, 0)-(t + 15, 15), PiecesMask(Offset)
  Offset = Offset + 67
NEXT t
END SUB

SUB Instructions
CLS
PRINT "Welcome to the QBasic chess reader for the QBChess program."
PRINT "After playing a game you can review the game score by entering"
PRINT "in the game file name when prompted. Hard coded the name must reside"
PRINT "within the current directory can be composed or the name (SCORE) plus"
PRINT "3 letters(001). So this reader can display 001 to 999. The program appends"
PRINT "the file extension as (.TXT) so you dont have to enter it."
PRINT "For example this is a valid entry  SCORE001"
PRINT "You can quit anytime by entering (Q) for quit!"
PRINT "This program composed by MickJW for QBGuys revised QBChess program"
PRINT "                   Any key to continue"
Dummy$ = INPUT$(1)
Dummy$ = ""
CLS
END SUB

SUB LoadDimListing (Succes, Totlines, FFileNName$)
'may need a global variable to allow change of direction when returning
'from error handler
'FFileNName$ = "TESTPGN.txt"
IF Succes = -1 THEN
  'FFileNName$ = "C:\qb45\" + FFileNName$ '<-------------------------------------------*************
  Totlines = 0
  ON ERROR GOTO ErrorHandler
  FileNum = FREEFILE
  OPEN FFileNName$ FOR INPUT AS #FileNum 'try to open file to parse
  DO WHILE NOT EOF(FileNum)
    INPUT #FileNum, Temp$
    IF Temp$ = "" THEN
      'blank line
    ELSE
      Totlines = Totlines + 1 'increment so we place in 1st element
      MoveList$(Totlines) = Temp$
    END IF
  LOOP
  CLOSE #FileNum
END IF
END SUB

SUB MakeSquareGraphics
CLS
LINE (0, 0)-(15, 15), 9, BF
GET (0, 0)-(15, 15), Squares(0)
LINE (0, 0)-(15, 15), 14, BF
GET (0, 0)-(15, 15), Squares(67)
CLS
END SUB

SUB MaskPieces
FOR x = 0 TO 95
  FOR y = 0 TO 31
    z = POINT(x, y)
    IF z = 0 THEN
      PSET (x, y), 15 'invisible becomes high color
    ELSE
      PSET (x, y), 0 'visible becomes low  color
    END IF
  NEXT y
NEXT x
END SUB

SUB Notes1
KCastle = FALSE: QCastle = FALSE: WhosMove = 1 '1=W , 0=B
Normal = FALSE: ENP = FALSE: Promotion = FALSE

'CurrentLine$ = "E2-E4  E7-E6"
'CurrentLine$ = "0-0  E7-E6"
'CurrentLine$ = "E7-E8-Q  E7-E6"
CurrentLine$ = "0-0-0  E7-E6"

'CurrentLine$ = MoveList$(MoveList)    'read current line
'Trimmer CurrentLine$
Length = LEN(CurrentLine$)

'divide line into seperate moves
FOR t = 1 TO Length
  A$ = MID$(CurrentLine$, t, 1)
  IF A$ = " " THEN EXIT FOR
NEXT t
WhiteMove$ = LEFT$(CurrentLine$, t - 1)

FOR t = Length TO 1 STEP -1
  A$ = MID$(CurrentLine$, t, 1)
  IF A$ = " " THEN EXIT FOR
NEXT t
BlackMove$ = RIGHT$(CurrentLine$, Length - t)

'get each string lengths
WLength = LEN(WhiteMove$)
BLength = LEN(BlackMove$)

'1] 0-0       = 3   kingside castle
'2] 0-0-0     = 5   queenside castle
'3] E2-E4     = 5   normal move
'4] E7-E8-Q   = 7   pawn promotion
'5] E5-F6-P   = 7   pawn en passent


PRINT WhiteMove$, BlackMove$, WLength, BLength
SLEEP 1
STOP

SString$ = WhiteMove$: LLength = WLength
SString$ = RTRIM$(LTRIM$(SString$))
PRINT SString$

'from the strings length discern if it normal or special move
SELECT CASE LLength
  CASE IS = 3
    'kingside castle
    KCastle = TRUE
    BEEP
  CASE IS = 5
    'posible normal or queenside castle
    IF SString$ = "0-0-0" THEN '<<== not recognising this!!!
      QCastle = TRUE
      BEEP
    ELSE
      Normal = TRUE
      BEEP
    END IF
  CASE IS = 7
    IF RIGHT$(SString$, 1) = "P" THEN
      'pawn en passent
      ENP = TRUE
      BEEP
    ELSE
      'pawn promotion
      Promotion = TRUE
      BEEP
    END IF
END SELECT

END SUB

SUB Proof10
'STOP
r = 12: c = 20
FOR height = 0 TO 7
  FOR wwidth = 0 TO 7
    'board has to be drawn from bottom left to top right
    Temp$ = STR$(BoardSquares(height, wwidth))
    Temp$ = RTRIM$(LTRIM$(Temp$))
    LOCATE r, c: PRINT Temp$
    c = c + 1
  NEXT wwidth
  r = r - 1
  c = 20
NEXT height
'STOP
END SUB

SUB Proof11
r = 12: c = 40
FOR height = 0 TO 7
  FOR wwidth = 0 TO 7
    'board has to be drawn from bottom left to top right
    Temp$ = STR$(Board(height, wwidth))
    Temp$ = RTRIM$(LTRIM$(Temp$))
    IF Temp$ = "" THEN
      COLOR 3
      LOCATE r, c: PRINT "0"
    END IF
    IF LEN(Temp$) = 1 THEN
      COLOR 7
      LOCATE r, c: PRINT Temp$
    END IF
    IF LEN(Temp$) = 2 THEN
      COLOR 1
      Temp$ = RIGHT$(Temp$, 1)
      LOCATE r, c: PRINT Temp$
    END IF
    c = c + 1
  NEXT wwidth
  r = r - 1
  c = 40
NEXT height
COLOR 7
'STOP
END SUB

SUB Proof12 (Totlines)
FOR t = 1 TO Totlines: PRINT MoveList$(t): NEXT t
END SUB

SUB Resetter (ThisPiece)
ThisPiece = 0
FOR t = 1 TO 4
  MoveFrom(t) = 0
  MoveTo(t) = 0
NEXT t
END SUB

'Pieces Identification 1=P,2=R,3=N,4=B,5=Q,6=K
'First Element refers to the height!!!
SUB SetUpBoardStart
'White Pawns
FOR t = 0 TO 7
  Board(1, t) = 1
NEXT t
'Rooks
Board(0, 0) = 2
Board(0, 7) = 2
'Knights
Board(0, 1) = 3
Board(0, 6) = 3
'Bishops
Board(0, 2) = 4
Board(0, 5) = 4
'Queen
Board(0, 3) = 5
'King
Board(0, 4) = 6

'Black Pawns
FOR t = 0 TO 7
  Board(6, t) = -1
NEXT t
'Rooks
Board(7, 0) = -2
Board(7, 7) = -2
'Knights
Board(7, 1) = -3
Board(7, 6) = -3
'Bishops
Board(7, 2) = -4
Board(7, 5) = -4
'Queen
Board(7, 3) = -5
'King
Board(7, 4) = -6

END SUB

SUB Trimmer (Temp$)
Temp$ = RTRIM$(LTRIM$(Temp$))
END SUB

SUB UpdateBoard

FOR h = 0 TO 7
  FOR w = 0 TO 7
    Piece = Board(h, w) 'check if square occupied
    OldPiece = Piece
    IF Piece <> 0 THEN 'get side of owner
      IF SGN(Piece) = -1 THEN 'draw black piece on this square
        Offset = 0
        GetCoords h, w, x, y, Offset, OldPiece
        PUT (y, x), PiecesMask(Offset), AND
        PUT (y, x), BPieces(Offset), OR
      END IF
      IF SGN(Piece) = 1 THEN 'draw white piece on this square
        Offset = 0
        GetCoords h, w, x, y, Offset, OldPiece
        PUT (y, x), PiecesMask(Offset), AND
        PUT (y, x), WPieces(Offset), OR
      END IF
    END IF
  NEXT w
  'SLEEP 1
NEXT h
END SUB